Index: main/plugin-web/plugin.xml
===================================================================
--- main/plugin-web/plugin.xml	(revision 26836)
+++ main/plugin-web/plugin.xml	(working copy)
@@ -2548,6 +2548,52 @@
 	 <!-- +
     	 | SITEMAP
     	 + -->
+     <feature name="userinterface.sitemap.create">
+		<extensions>
+    		<!-- Ajouter une page -->
+    		<extension id="org.ametys.web.userinterface.AddPage"
+					   point="org.ametys.cms.workspace.ribbon.RibbonControlsManager" 
+					   class="org.ametys.web.clientsideelement.AddPageClientSideElement">
+				<action class="org.ametys.ribbon.control.button.SitemapOrModifiablePageActionButton">
+					<param name="action">org.ametys.web.tool.page.Add.act</param>
+
+					<param name="label" i18n="true">PLUGINS_WEB_UITOOL_ADDPAGE_LABEL</param>
+					<param name="default-description" i18n="true">PLUGINS_WEB_UITOOL_ADDPAGE_DESC</param>
+					<param name="no-right-description" i18n="true">PLUGINS_WEB_UITOOL_PAGE_NORIGHT_DESC</param>
+					<param name="no-selection-description" i18n="true">PLUGINS_WEB_UITOOL_PAGE_NOSELECTION_DESC</param>
+					<param name="footer" i18n="true">PLUGINS_WEB_UITOOL_ADDPAGE_FOOTER</param>
+					<param name="icon-small" file="true">img/actions/page_add_16.png</param>
+					<param name="icon-medium" file="true">img/actions/page_add_32.png</param>
+					<param name="icon-large" file="true">img/actions/page_add_50.png</param>
+					
+					<param name="workflowInitActionId">1</param>
+					<param name="workflow-workflowName">content</param>	
+					<param name="workflowEditActionId">2</param>
+					
+					<param name="right-addcontent">Web_Rights_Page_AddContent</param>
+					<param name="right-addservice">Web_Rights_Page_AddService</param>
+					<param name="right-settemplate">Web_Rights_Page_Templates</param>
+					<param name="right-setlinkpage">Web_Rights_Page_LinkPage</param>
+					<param name="right-tag-page">Web_Rights_Page_Tag</param>
+                    <param name="right-tagprivate-page">Web_Rights_Page_Private_Tag</param>
+                    <param name="right-tag-content">Web_Rights_Content_Tag</param>
+                    <param name="right-tagprivate-content">Web_Rights_Content_Private_Tag</param>				</action>
+				<scripts>
+					<file>js/org/ametys/web/tool/page/Actions.i18n.js</file>
+					<file>js/org/ametys/web/tool/page/AddPageWizzard.i18n.js</file>
+					<file>js/org/ametys/ribbon/control/button/SitemapOrModifiablePageActionButton.js</file>
+					<file>js/org/ametys/web/page/TemplatesMenu.i18n.js</file>	
+					<file>js/org/ametys/web/page/LinkPage.i18n.js</file>		
+					<file>js/org/ametys/web/zone/AddContentAction.i18n.js</file>
+					<file>js/org/ametys/web/zone/AddServiceAction.i18n.js</file>
+				</scripts>
+				<css>
+					<file>css/pages/addpage.css</file>
+				</css>
+				<right>Web_Rights_Page_Handle</right>
+			</extension>
+		</extensions>     
+     </feature>
 	 <feature name="userinterface.sitemap">
     	<extensions>
 			<extension id="org.ametys.web.userinterface.Sitemap"
@@ -2588,29 +2634,6 @@
 		       	</css>
     		</extension>
     		
-    		<!-- Ajouter une page -->
-    		<extension id="org.ametys.web.userinterface.AddPage"
-					   point="org.ametys.cms.workspace.ribbon.RibbonControlsManager" 
-					   class="org.ametys.runtime.ui.impl.StaticContextualClientSideElement">
-				<action class="org.ametys.ribbon.control.button.SitemapOrModifiablePageActionButton">
-					<param name="action">org.ametys.web.tool.page.Add.act</param>
-
-					<param name="label" i18n="true">PLUGINS_WEB_UITOOL_ADDPAGE_LABEL</param>
-					<param name="default-description" i18n="true">PLUGINS_WEB_UITOOL_ADDPAGE_DESC</param>
-					<param name="no-right-description" i18n="true">PLUGINS_WEB_UITOOL_PAGE_NORIGHT_DESC</param>
-					<param name="no-selection-description" i18n="true">PLUGINS_WEB_UITOOL_PAGE_NOSELECTION_DESC</param>
-					<param name="footer" i18n="true">PLUGINS_WEB_UITOOL_ADDPAGE_FOOTER</param>
-					<param name="icon-small" file="true">img/actions/page_add_16.png</param>
-					<param name="icon-medium" file="true">img/actions/page_add_32.png</param>
-					<param name="icon-large" file="true">img/actions/page_add_50.png</param>
-				</action>
-				<scripts>
-					<file>js/org/ametys/web/tool/page/Actions.i18n.js</file>
-					<file>js/org/ametys/ribbon/control/button/SitemapOrModifiablePageActionButton.js</file>
-				</scripts>
-				<right>Web_Rights_Page_Handle</right>
-			</extension>
-			
 			<!-- Supprimer une page -->
     		<extension id="org.ametys.web.userinterface.DeletePage"
 					   point="org.ametys.cms.workspace.ribbon.RibbonControlsManager" 
@@ -2903,6 +2926,9 @@
 					<file>css/all.css</file>
 				</css>
 				<right>Web_Rights_Content_Tag</right>
+				<right>Web_Rights_Content_Private_Tag</right>
+                <right>Web_Rights_Page_Tag</right>
+                <right>Web_Rights_Page_Private_Tag</right>
 			</extension>
 			
     	</extensions>
@@ -3048,6 +3074,7 @@
 					<param name="search-factory-role">uitool-web-last-publication-search</param>
 				</action>
 				<scripts>
+					<file>js/org/ametys/web/helper/ChooseContentBySearch.i18n.js</file>
 					<file>js/org/ametys/web/editor/InsertLastPublicationAction.i18n.js</file>
 				</scripts>
 				<right>Web_Right_InsertLastPublication</right>
@@ -3539,7 +3566,6 @@
 					
 					<param name="workflowInitActionId">1</param>
 					<param name="workflow-workflowName">content</param>
-					<param name="content-language-to-create">fr</param> <!-- FIXME hardcoded -->
 				</action>
 				<scripts>
 					<file plugin="cms">js/org/ametys/cms/ribbon/button/Menu.js</file>
@@ -3574,6 +3600,9 @@
 
 					<param name="workflowInitActionId">1</param>
 					<param name="workflow-workflowName">content</param>
+					
+					<param name="content-tool-edit-mode">true</param>
+                    <param name="content-tool-save-action-id">2</param>
 				</action>
 				<menu-item id="org.ametys.web.sharedcontent">
 					<param name="action">org.ametys.web.content.SharedContentAction</param>
@@ -3824,7 +3853,6 @@
 				<label i18n="true">PLUGINS_WEB_SERVICE_SITEMAP_LABEL</label>
 				<description i18n="true">PLUGINS_WEB_SERVICE_SITEMAP_DESCRIPTION</description>
 				<thumbnail>
-					<small>img/service/sitemap_16.png</small>
 					<medium>img/service/sitemap_32.png</medium>
 					<large>img/service/sitemap_48.png</large>
 				</thumbnail>
@@ -3916,7 +3944,7 @@
                             <enumeration>
                                 <custom-enumerator class="org.ametys.web.frontoffice.ContentTypesForSearchEnumerator"/>
                             </enumeration>
-                            <widget>sorted-multiselect</widget>
+                            <widget>content-types</widget>
                         </parameter>
                         <parameter name="search-by-content-types-choice" type="string" multiple="false">
                             <label i18n="true">PLUGINS_WEB_SERVICE_FRONT_SEARCH_BY_CONTENTTYPE_CHOICE</label>
@@ -3943,12 +3971,33 @@
                                     <value>none</value>
                                 </entry>
                             </enumeration>
+                         	<default-value>none</default-value>
+                        </parameter>
+                        <parameter name="search-by-common-date-begin" type="string" multiple="false">
+                        	<label i18n="true">PLUGINS_WEB_SERVICE_FRONT_SEARCH_BY_CONTENTTYPE_CHOICE_DATE_BEGIN</label>
+                        	<description i18n="true">PLUGINS_WEB_SERVICE_FRONT_SEARCH_BY_CONTENTTYPE_CHOICE_DATE_BEGIN_DESC</description>
+                        	<widget>typed-metadata</widget>
+                        	<widget-params>
+                            	<param name="metadataSetName">index</param>
+                                <param name="metadataType">DATE</param>
+                            </widget-params>
+                        </parameter>
+                         <parameter name="search-by-common-date-end" type="string" multiple="false">
+                        	<label i18n="true">PLUGINS_WEB_SERVICE_FRONT_SEARCH_BY_CONTENTTYPE_CHOICE_DATE_END</label>
+                        	<description i18n="true">PLUGINS_WEB_SERVICE_FRONT_SEARCH_BY_CONTENTTYPE_CHOICE_DATE_END_DESC</description>
+                        	<widget>typed-metadata</widget>
+                        	<widget-params>
+								<param name="metadataSetName">index</param>
+                                <param name="metadataType">DATE</param>
+                            </widget-params>
                         </parameter>
                         <parameter name="advanced-search" type="boolean">
                             <label i18n="true">PLUGINS_WEB_SERVICE_FRONT_SEARCH_ADVANCED_SEARCH</label>
                             <description i18n="true">PLUGINS_WEB_SERVICE_FRONT_SEARCH_ADVANCED_SEARCH_DESC</description>
                         </parameter>
-                        <parameter name="search-by-pages" type="string" multiple="true">
+                    </group>
+                    <group>
+                    	<parameter name="search-by-pages" type="string" multiple="true">
                             <label i18n="true">PLUGINS_WEB_SERVICE_FRONT_SEARCH_BY_SECTION</label>
                             <description i18n="true">PLUGINS_WEB_SERVICE_FRONT_SEARCH_BY_SECTION_DESC</description>
                             <widget>current-sitemap</widget>
@@ -3961,8 +4010,8 @@
                             	<param name="allowProviders">true</param>
                                 <param name="onlyTagsWithChildren">true</param>
                             </widget-params>
-                        </parameter>
-                        <parameter name="strict-search-on-tags" type="boolean">
+                        </parameter>  
+                   		<parameter name="strict-search-on-tags" type="boolean">
                             <label i18n="true">PLUGINS_WEB_SERVICE_FRONT_SEARCH_STRICT_SEARCH_ON_TAGS</label>
                             <description i18n="true">PLUGINS_WEB_SERVICE_FRONT_SEARCH_STRICT_SEARCH_ON_TAGS_DESC</description>
                         </parameter>
@@ -3970,8 +4019,6 @@
                             <label i18n="true">PLUGINS_WEB_SERVICE_FRONT_SEARCH_ON_ALL_SITES</label>
                             <description i18n="true">PLUGINS_WEB_SERVICE_FRONT_SEARCH_ON_ALL_SITES_DESC</description>
                         </parameter>
-                    </group>
-                    <group>
                         <parameter name="search-mode" type="string">
                             <label i18n="true">PLUGINS_WEB_SERVICE_FRONT_SEARCH_MODE</label>
                             <description i18n="true">PLUGINS_WEB_SERVICE_FRONT_SEARCH_MODE_DESC</description>