Index: main/plugin-explorer/src/org/ametys/plugins/explorer/ExplorerNodeGenerator.java
===================================================================
--- main/plugin-explorer/src/org/ametys/plugins/explorer/ExplorerNodeGenerator.java	(revision 27343)
+++ main/plugin-explorer/src/org/ametys/plugins/explorer/ExplorerNodeGenerator.java	(working copy)
@@ -24,7 +24,6 @@
 import org.apache.cocoon.xml.XMLUtils;
 import org.xml.sax.SAXException;
 
-import org.ametys.plugins.explorer.resources.ModifiableResourceCollection;
 import org.ametys.plugins.explorer.resources.generators.ResourcesExplorerGenerator;
 import org.ametys.plugins.repository.AmetysObject;
 import org.ametys.plugins.repository.AmetysObjectIterable;
@@ -109,7 +108,7 @@
             childAtts.addCDATAAttribute("isModifiable", "true");
         }
         
-        if (node instanceof ModifiableResourceCollection)
+        if (node instanceof ModifiableExplorerNode)
         {
             childAtts.addCDATAAttribute("canCreateChild", "true");
         }
Index: main/plugin-explorer/src/org/ametys/plugins/explorer/resources/ModifiableResourceCollection.java
===================================================================
--- main/plugin-explorer/src/org/ametys/plugins/explorer/resources/ModifiableResourceCollection.java	(revision 27343)
+++ main/plugin-explorer/src/org/ametys/plugins/explorer/resources/ModifiableResourceCollection.java	(working copy)
@@ -15,13 +15,14 @@
  */
 package org.ametys.plugins.explorer.resources;
 
+import org.ametys.plugins.explorer.ModifiableExplorerNode;
 import org.ametys.plugins.repository.ModifiableTraversableAmetysObject;
 import org.ametys.plugins.repository.RemovableAmetysObject;
 
 /**
  * Common interface for modifiable resource collection
  */
-public interface ModifiableResourceCollection extends ModifiableTraversableAmetysObject, ResourceCollection, RemovableAmetysObject
+public interface ModifiableResourceCollection extends ModifiableTraversableAmetysObject, ResourceCollection, RemovableAmetysObject, ModifiableExplorerNode
 {
     /**
      * Get the type of child resources
Index: main/plugin-explorer/src/org/ametys/plugins/explorer/resources/generators/UserRightsGenerator.java
===================================================================
--- main/plugin-explorer/src/org/ametys/plugins/explorer/resources/generators/UserRightsGenerator.java	(revision 27343)
+++ main/plugin-explorer/src/org/ametys/plugins/explorer/resources/generators/UserRightsGenerator.java	(working copy)
@@ -28,6 +28,7 @@
 import org.apache.cocoon.xml.XMLUtils;
 import org.xml.sax.SAXException;
 
+import org.ametys.plugins.explorer.ExplorerNode;
 import org.ametys.plugins.explorer.resources.ResourceCollection;
 import org.ametys.plugins.repository.AmetysObjectResolver;
 import org.ametys.runtime.right.RightsManager;
@@ -60,10 +61,10 @@
         Request request = ObjectModelHelper.getRequest(objectModel);
         String id = request.getParameter("explorerNodeId");
         
-        ResourceCollection collection = (ResourceCollection) _resolver.resolveById(id);
+        ExplorerNode node = (ExplorerNode) _resolver.resolveById(id);
         
         String login = _userProvider.getUser();
-        Set<String> rights = _rightsManager.getUserRights(login, "/resources" + collection.getExplorerPath());
+        Set<String> rights = _rightsManager.getUserRights(login, "/resources" + node.getExplorerPath());
 
         contentHandler.startDocument();
         XMLUtils.startElement(contentHandler, "user-rights");
Index: main/plugin-explorer/src/org/ametys/plugins/explorer/resources/generators/ExplorerEntitiesGenerator.java
===================================================================
--- main/plugin-explorer/src/org/ametys/plugins/explorer/resources/generators/ExplorerEntitiesGenerator.java	(revision 27343)
+++ main/plugin-explorer/src/org/ametys/plugins/explorer/resources/generators/ExplorerEntitiesGenerator.java	(working copy)
@@ -36,9 +36,7 @@
     @Override
     public void generate() throws IOException, SAXException, ProcessingException
     {
-        @SuppressWarnings("unchecked")
         Map<String, Object> jsParameters = (Map<String, Object>) objectModel.get(ObjectModelHelper.PARENT_CONTEXT);
-        @SuppressWarnings("unchecked")
         List<String> ids = (List<String>) jsParameters.get("ids");
         
         contentHandler.startDocument();
Index: main/plugin-explorer/src/org/ametys/plugins/explorer/cmis/CMISRootResourcesCollection.java
===================================================================
--- main/plugin-explorer/src/org/ametys/plugins/explorer/cmis/CMISRootResourcesCollection.java	(revision 27343)
+++ main/plugin-explorer/src/org/ametys/plugins/explorer/cmis/CMISRootResourcesCollection.java	(working copy)
@@ -298,7 +298,6 @@
         }
     }
 
-    @SuppressWarnings("unchecked")
     @Override
     public <A extends AmetysObject> A getParent() throws AmetysRepositoryException
     {
Index: main/plugin-explorer/src/org/ametys/plugins/explorer/ModifiableExplorerNode.java
===================================================================
--- main/plugin-explorer/src/org/ametys/plugins/explorer/ModifiableExplorerNode.java	(revision 0)
+++ main/plugin-explorer/src/org/ametys/plugins/explorer/ModifiableExplorerNode.java	(revision 0)
@@ -0,0 +1,25 @@
+/*
+ *  Copyright 2014 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.plugins.explorer;
+
+import org.ametys.plugins.repository.ModifiableAmetysObject;
+
+/**
+ * ExplorerNode that can have child explorer nodes
+ */
+public interface ModifiableExplorerNode extends ExplorerNode, ModifiableAmetysObject
+{
+}