Index: main/plugin-calendar/pages/services/calendar/calendar.xsl
===================================================================
--- main/plugin-calendar/pages/services/calendar/calendar.xsl	(revision 28406)
+++ main/plugin-calendar/pages/services/calendar/calendar.xsl	(working copy)
@@ -76,9 +76,10 @@
                         
                         for (var i = 0; i &lt; events.length; i++)
                         {
+                            var startingMonth = events[i].start.substring(0,events[i].start.length - 3);  
                             if (isEvent(date, events[i]))
                             {
-                                var id = 'event-<xsl:value-of select="$uniqueId"/>-' + events[i].eventId;
+                                var id =  'event-' + startingMonth + '-<xsl:value-of select="$uniqueId"/>-' + events[i].eventId;
                                 html += $j('#' + id).html();
                             }
                         }
@@ -193,13 +194,16 @@
 		                                        <ul>
 		                                            <xsl:for-each select="/events/months/month">
 		                                                <xsl:if test="/events/contents/event[starts-with(content/metadata/start-date, current()/@str)]">
+                                                            <xsl:variable name="str">
+		                                                      <xsl:value-of select="@str"/>
+		                                                    </xsl:variable>
 		                                                    <li class="month {@str}">
 		                                                        <span>
 		                                                            <i18n:date src-pattern="yyyy-MM-dd'T'hh:mm:ss" pattern="MMMM yyyy" value="{@raw}"/>
 		                                                        </span>
 		                                                        <ul>
 		                                                            <xsl:for-each select="/events/contents/event[starts-with(content/metadata/start-date, current()/@str)]">
-		                                                                <li id="event-{$uniqueId}-{substring-after(content/@id, '//')}" class="event">
+		                                                                <li id="event-{$str}-{$uniqueId}-{substring-after(content/@id, '//')}" class="event">
 		                                                                    <xsl:copy-of select="view/content/html/body/node()"/>
 		                                                                </li>
 		                                                            </xsl:for-each>
Index: main/plugin-calendar/pages/services/calendar/calendar_1.3.xsl
===================================================================
--- main/plugin-calendar/pages/services/calendar/calendar_1.3.xsl	(revision 28406)
+++ main/plugin-calendar/pages/services/calendar/calendar_1.3.xsl	(working copy)
@@ -82,16 +82,17 @@
             var events = events<xsl:value-of select="$uniqueId"/>;
             
             var date = $j.datepicker.parseDate('yy-mm-dd', dateText);
-            
+
             if (samePage<xsl:value-of select="$uniqueId"/>)
             {
                 var html = '';
                 
                 for (var i = 0; i &lt; events.length; i++)
                 {
+                    var startingMonth = events[i].start.substring(0,events[i].start.length - 3);                
                     if (isEvent(date, events[i]))
                     {
-                        var id = 'event-<xsl:value-of select="$uniqueId"/>-' + events[i].eventId;
+                        var id = 'event-' + startingMonth + '-<xsl:value-of select="$uniqueId"/>-' + events[i].eventId;
                         html += "&lt;li&gt;" + $j('#' + id).html() + "&lt;/li&gt;";
                     }
                 }
@@ -281,13 +282,16 @@
 						                <ul>
 						                    <xsl:for-each select="/events/months/month">
 						                        <xsl:if test="/events/contents/event[event:inMonth(current()/@raw, content/metadata/start-date, content/metadata/end-date)]">
+						                            <xsl:variable name="str">
+						                              <xsl:value-of select="@str"/>
+					                                </xsl:variable>
 						                            <li class="month {@str}">
 						                                <span>
 						                                    <i18n:date src-pattern="yyyy-MM-dd'T'hh:mm:ss" pattern="MMMM yyyy" value="{@raw}"/>
 						                                </span>
 						                                <ul>
 						                                    <xsl:for-each select="/events/contents/event[event:inMonth(current()/@raw, content/metadata/start-date, content/metadata/end-date)]">
-						                                        <li id="event-{$uniqueId}-{substring-after(content/@id, '//')}" class="event">
+						                                        <li id="event-{$str}-{$uniqueId}-{substring-after(content/@id, '//')}" class="event">
 						                                            <xsl:copy-of select="view/content/html/body/node()"/>
 						                                        </li>
 						                                    </xsl:for-each>